

#include "FlashEeprom.h"



const static uint32_t FLASH_START_ADDRESS = 0x08000000+4096*80;//64,ÿ1K
volatile FLASH_Status FLASHStatus = FLASH_COMPLETE;


volatile uint8_t EepromBuf[SizeOfEepromBuf] = {0};

uint32_t FlashWrite(uint32_t addr, uint8_t *buffer, uint32_t length)
{
    uint16_t i, data = 0;

    //96000000Ҫϵͳ2ƵҪָ
     RCC->CFGR0 |= (uint32_t)RCC_HPRE_DIV2;
    __disable_irq();
    USART_Printf_Init(115200);


    FLASH_Unlock();
    FLASH_ClearFlag(FLASH_FLAG_BSY | FLASH_FLAG_EOP | FLASH_FLAG_WRPRTERR);
    FLASHStatus = FLASH_ErasePage(FLASH_START_ADDRESS);

    printf("FLASH Erase Suc\r\n");
  for(i = 0; i < length; i += 2)
  {
    data = (*(buffer + i + 1) << 8) + (*(buffer + i));
    if(FLASH_ProgramHalfWord((uint32_t)(addr+FLASH_START_ADDRESS + i), data) != FLASH_COMPLETE)
    {

        printf(" != FLASH_COMPLETE\r\n");
        FLASH_Lock();
        RCC->CFGR0 &= ~(uint32_t)RCC_HPRE_DIV2;
        __enable_irq();
      return i;
    }
  }
  printf(" Suc  \r\n");


  FLASH_Lock();
//   RCC->CFGR0 &= ~(uint32_t)RCC_HPRE_DIV2;
  RCC->CFGR0 |= (uint32_t)RCC_HPRE_DIV1;
  __enable_irq();

  return length;
}



uint32_t FlashRead(uint32_t ReadAddress, uint8_t *buffer, uint32_t length)
{
    int DataNum = 0;
    ReadAddress = (uint32_t)FLASH_START_ADDRESS + ReadAddress;
    while(DataNum < length)
    {
         *(buffer + DataNum) = *(__IO uint8_t*) ReadAddress++;

         DataNum++;
    }
    return DataNum;
}



